
VisIt - Bug # 1210: static build issues pending for 2.6 release

Status: Pending Priority: Normal

Author: Cyrus Harrison Category:

Created: 10/03/2012 Assigned to:

Updated: 01/16/2013 Due date:

Likelihood: 3 - Occasional

Severity: 3 - Major Irritation

Found in Version: trunk

OS: All

Support Group: Any

Subject: static build issues pending for 2.6 release

Description: Info is from the llnl buildbots (OSX 16.0 & rhel 6.3):





build_visit will successfully create static 3rd- party, if I disable the following libs:


 hdf4


 adios


 ccmio


 boxlib


 pyside





Note, the following are not tested by the buildbot b/c the require http access:


 h5part


 fastbit


 itaps








Current VisIt build problem: (I don't use mpi for my static builds, looks like DDT stuff needs to guard on MPI)





/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/main-linux-static/build/src/sim/V2/ddtsim/ddtsim.cpp

:62:19: error: mpi.h: No such file or directory


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/main-linux-static/build/src/sim/V2/ddtsim/ddtsim.cpp

: In function 'int ddtMpiCompat_Bcast(void*, int, int, int, int)':


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/main-linux-static/build/src/sim/V2/ddtsim/ddtsim.cpp

:143: error: 'MPI_Datatype' was not declared in this scope


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/main-linux-static/build/src/sim/V2/ddtsim/ddtsim.cpp

:143: error: expected ';' before 'mpitype'


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/main-linux-static/build/src/sim/V2/ddtsim/ddtsim.cpp

:146: error: 'mpitype' was not declared in this scope


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/main-linux-static/build/src/sim/V2/ddtsim/ddtsim.cpp

:146: error: 'MPI_INT' was not declared in this scope


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/main-linux-static/build/src/sim/V2/ddtsim/ddtsim.cpp

:147: error: 'MPI_CHAR' was not declared in this scope


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/main-linux-static/build/src/sim/V2/ddtsim/ddtsim.cpp

:152: error: 'mpitype' was not declared in this scope


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/main-linux-static/build/src/sim/V2/ddtsim/ddtsim.cpp

:152: error: 'MPI_COMM_WORLD' was not declared in this scope


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/main-linux-static/build/src/sim/V2/ddtsim/ddtsim.cpp

:152: error: 'MPI_Bcast' was not declared in this scope


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/main-linux-static/build/src/sim/V2/ddtsim/ddtsim.cpp

: In function 'void ddtMpiCompat_rankAndSize(int*, int*)':


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/main-linux-static/build/src/sim/V2/ddtsim/ddtsim.cpp

:173: error: 'MPI_COMM_WORLD' was not declared in this scope
/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/main-linux-static/build/src/sim/V2/ddtsim/ddtsim.cpp

:173: error: 'MPI_Comm_rank' was not declared in this scope


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/main-linux-static/build/src/sim/V2/ddtsim/ddtsim.cpp

:174: error: 'MPI_Comm_size' was not declared in this scope


make[2]: *** [sim/V2/ddtsim/CMakeFiles/ddtsim_static.dir/ddtsim.cpp.o] Error 1


make[1]: *** [sim/V2/ddtsim/CMakeFiles/ddtsim_static.dir/all] Error 2


make: *** [all] Error 2





I think there is a netcdf problem lurking as well, I will post after this first issue is resolved. 


History

10/11/2012 02:09 pm - Eric Brugger

- Target version deleted (2.6)

10/11/2012 02:10 pm - Eric Brugger

- Target version set to 2.6.1

10/11/2012 02:13 pm - Eric Brugger

- Status changed from New to Pending

12/10/2012 11:57 am - Cyrus Harrison

The DDT issue was resolve, there are still a few HDF5 linking errors:








[ 93%] Building CXX object tools/convert/CMakeFiles/visitconvert_ser.dir/ConvertStaticSymbolLocator.C.o


Linking CXX executable ../../exe/visitconvert_ser


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/deps-linux-static/build/visit/netcdf/4.1.1/bbot/lib/libnetcdf.a(nc4hdf.o): In function 

`commit_type':


nc4hdf.c:(.text+0x5504): undefined reference to `H5Tcommit1'


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/deps-linux-static/build/visit/hdf5/1.8.7/bbot/lib/libhdf5_hl.a(H5LT.o): In function 

`H5LT_dtype_to_text':


H5LT.c:(.text+0x2819): undefined reference to `H5Tget_tag'


H5LT.c:(.text+0x2a95): undefined reference to `H5Tget_cset'


H5LT.c:(.text+0x2bb0): undefined reference to `H5Tset_cset'


H5LT.c:(.text+0x353b): undefined reference to `H5Tset_cset'


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/deps-linux-static/build/visit/hdf5/1.8.7/bbot/lib/libhdf5_hl.a(H5LTparse.o): In function 

`H5LTyyparse':


H5LTparse.c:(.text+0x81d): undefined reference to `H5Tset_tag'


H5LTparse.c:(.text+0xdd3): undefined reference to `H5Tset_cset'


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/deps-linux-static/build/visit/silo/4.8/bbot/lib/libsiloh5.a(silo_hdf5.o): In function 

`db_hdf5_InqMeshName':


silo_hdf5.c:(.text+0x83ab): undefined reference to `H5Topen1'


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/deps-linux-static/build/visit/silo/4.8/bbot/lib/libsiloh5.a(silo_hdf5.o): In function 

`db_hdf5_hdrwr':


silo_hdf5.c:(.text+0x867f): undefined reference to `H5Topen1'


silo_hdf5.c:(.text+0x8a10): undefined reference to `H5Tcommit1'


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/deps-linux-static/build/visit/silo/4.8/bbot/lib/libsiloh5.a(silo_hdf5.o): In function 

`db_hdf5_GetMrgtree':


silo_hdf5.c:(.text+0xf3a4): undefined reference to `H5Topen1'


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/deps-linux-static/build/visit/silo/4.8/bbot/lib/libsiloh5.a(silo_hdf5.o): In function 

`db_hdf5_GetZonelist':


silo_hdf5.c:(.text+0xfe5e): undefined reference to `H5Topen1'
/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/deps-linux-static/build/visit/silo/4.8/bbot/lib/libsiloh5.a(silo_hdf5.o): In function 

`db_hdf5_PutUcdsubmesh':


silo_hdf5.c:(.text+0x17d7a): undefined reference to `H5Topen1'


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/deps-linux-static/build/visit/silo/4.8/bbot/lib/libsiloh5.a(silo_hdf5.o): In function 

`db_hdf5_PutMultimeshadj':


silo_hdf5.c:(.text+0x1a79f): undefined reference to `H5Topen1'


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/deps-linux-static/build/visit/silo/4.8/bbot/lib/libsiloh5.a(silo_hdf5.o): In function 

`db_hdf5_GetMultimatspecies':


silo_hdf5.c:(.text+0x1c1a0): undefined reference to `H5Topen1'


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/deps-linux-static/build/visit/silo/4.8/bbot/lib/libsiloh5.a(silo_hdf5.o):silo_hdf5.c:(.text+0x1c65e)

: more undefined references to `H5Topen1' follow


/scratch/harrison37/buildbot/sandbox/cdh-rhel-6.3-x86_64/deps-linux-static/build/visit/silo/4.8/bbot/lib/libsiloh5.a(H5FDsilo.o): In function 

`H5Pset_fapl_silo':


H5FDsilo.c:(.text+0x8ec): undefined reference to `H5Pinsert1'


H5FDsilo.c:(.text+0x932): undefined reference to `H5Pinsert1'


H5FDsilo.c:(.text+0x978): undefined reference to `H5Pinsert1'


H5FDsilo.c:(.text+0x9be): undefined reference to `H5Pinsert1'


collect2: ld returned 1 exit status


make[2]: *** [exe/visitconvert_ser] Error 1


make[1]: *** [tools/convert/CMakeFiles/visitconvert_ser.dir/all] Error 2


make: *** [all] Error 2


program finished with exit code 2


elapsedTime=1943.042921

12/19/2012 10:48 am - Cyrus Harrison

I looked into this a bit, it appears to be an issue with the order of the linking:

I was able to get visitconvert to link by hand when the relative order of the netcdf, silo and hdf5 libs looked like the following:

-lnetcdf_c++ -lhdf5_hl -lsiloh5 -lhdf5  -lszip

We need a better way to resolve external deps for the static build case. I tried a few quick fixes, but they all lead to different sets of linking errors.

The fundamental issue is that we don't have a way to recreate the dependency graph, it doesn't matter for shared libs, but it matters for many 

compilers for static builds. It would be nice if we could figure out the proper way to do this with CMake.

01/10/2013 11:39 am - Cyrus Harrison

LINK_INTERFACE_LIBRARIES may help, but the docs are quite confusing. 





http://www.cmake.org/cmake/help/v2.8.2/cmake.html#prop_tgt:LINK_INTERFACE_LIBRARIES





The problem we have is the following:


External libA links to external libZZZ


External libB links to external libZZZ





An exe links both libA and libB.





With our current system, the order that libZZZ appears on the link line (which is important for some compilers) does not respect the full dependency 
graph. I think this is a side effect of of our attempt to handle deps with our config-site infrastructure.








01/16/2013 06:40 pm - Cyrus Harrison

- Target version changed from 2.6.1 to 2.6.2
